package com.ynet.life.cache;

import com.ynet.life.cache.Cache;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class LRUCache implements Cache {

   private int cacheSize;
   private Map map = Collections.synchronizedMap(new HashMap());
   private List keyList = Collections.synchronizedList(new LinkedList());


   public Object get(Object key) {
      Object o;
      if((o = this.map.get(key)) != null) {
         this.keyList.remove(key);
         this.keyList.add(key);
      }

      return o;
   }

   public void put(Object o, Object value) {
      if(!this.keyList.contains(o)) {
         this.keyList.add(o);
         this.map.put(o, value);
         if(this.keyList.size() > this.cacheSize) {
            o = this.keyList.remove(0);
            this.map.remove(o);
         }

      }
   }

   public void remove(Object key) {
      this.map.remove(key);
      this.keyList.remove(key);
   }

   public void clear() {
      this.map.clear();
      this.keyList.clear();
   }

   public void configure(int size) {
      this.cacheSize = size;
   }

   public static void main(String[] c) {
      LRUCache c1;
      (c1 = new LRUCache()).configure(4);
      c1.put("1", "1");
      c1.put("2", "2");
      c1.put("3", "3");
      c1.put("4", "4");
      c1.get("1");
      c1.get("2");
      c1.put("5", "5");
      c1.put("5", "5");
      c1.get("4");
      c1.put("6", "6");
      System.out.println(c1.get("4"));
   }

   public String getCacheName() {
      return null;
   }
}
